Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/AssignedJobResource.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/AssignedJobResource.cs	(revision 16386)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/AssignedJobResource.cs	(revision 16386)
@@ -0,0 +1,36 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.Hive.DataTransfer {
+  [DataContract]
+  [Serializable]
+  public class AssignedJobResource : HiveItem {
+    [DataMember]
+    public Guid JobId { get; set; }
+    [DataMember]
+    public Guid ResourceId { get; set; }
+
+    public AssignedJobResource() { }
+  }
+}
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/AssignedProjectResource.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/AssignedProjectResource.cs	(revision 16386)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/AssignedProjectResource.cs	(revision 16386)
@@ -0,0 +1,36 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.Hive.DataTransfer {
+  [DataContract]
+  [Serializable]
+  public class AssignedProjectResource : HiveItem {
+    [DataMember]
+    public Guid ProjectId { get; set; }
+    [DataMember]
+    public Guid ResourceId { get; set; }
+
+    public AssignedProjectResource() { }
+  }
+}
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/Job.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/Job.cs	(revision 15962)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/Job.cs	(revision 16386)
@@ -32,9 +32,11 @@
     public DateTime DateCreated { get; set; }
     [DataMember]
-    public string ResourceNames { get; set; }
+    public Guid ProjectId { get; set; }
     [DataMember]
     public Permission Permission { get; set; } // the permission for the currently logged in user
     [DataMember]
     public string OwnerUsername { get; set; }
+    [DataMember]
+    public JobState State { get; set; }
 
     /* ==== some computed statistics ==== */
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/JobState.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/JobState.cs	(revision 16386)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/JobState.cs	(revision 16386)
@@ -0,0 +1,45 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Services.Hive.DataTransfer {
+  [Serializable]
+  public enum JobState {
+    /// <summary>
+    /// A job is online as long as he is no other state.
+    /// </summary>
+    Online,
+
+    /// <summary>
+    /// A job is in StatisticsPending if its deletion has been requested,
+    /// but the final generation of statistics hasn't been performed yet.
+    /// </summary>
+    StatisticsPending,
+
+    /// <summary>
+    /// A job is in DeletionPending if its deletion has been requested,
+    /// the final generation of statistics has already been performed,
+    /// but the eventual deletion of the job is still pending. 
+    /// </summary>
+    DeletionPending
+  };
+
+  public static class JobStateExtensions {
+    /// <summary>
+    /// This job is online
+    /// </summary>
+    public static bool IsOnline(this JobState jobState) {
+      return jobState == JobState.Online;
+    }
+
+    /// <summary>
+    /// This job is still existent, but already flagged for deletion.
+    /// Usually the flag is set by a user, not a resource or the janitor or something else.
+    /// </summary>
+    public static bool IsFlaggedForDeletion(this JobState jobState) {
+      return jobState == JobState.StatisticsPending || jobState == JobState.DeletionPending;
+    }
+  }
+}
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/Project.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/Project.cs	(revision 16386)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/Project.cs	(revision 16386)
@@ -0,0 +1,42 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.Hive.DataTransfer {
+  [DataContract]
+  [Serializable]
+  public class Project : NamedHiveItem {
+    [DataMember]
+    public Guid? ParentProjectId { get; set; }
+    [DataMember]
+    public DateTime DateCreated { get; set; }
+    [DataMember]
+    public Guid OwnerUserId { get; set; }
+    [DataMember]
+    public DateTime StartDate { get; set; }
+    [DataMember]
+    public DateTime? EndDate { get; set; }
+
+    public Project() { }
+  }
+}
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/ProjectPermission.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/ProjectPermission.cs	(revision 16386)
+++ branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/ProjectPermission.cs	(revision 16386)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.Hive.DataTransfer {
+  [DataContract]
+  [Serializable]
+  public class ProjectPermission : HiveItem {
+    // info: this class is derived from HiveItem to simplify handling on the client side, altough it does not have a Id.
+    [DataMember]
+    public Guid ProjectId { get; set; }
+    [DataMember]
+    public Guid GrantedUserId { get; set; }
+    [DataMember]
+    public Guid GrantedByUserId { get; set; }
+
+    public ProjectPermission() { }
+  }
+}
Index: branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/ResourcePermission.cs
===================================================================
--- branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/DataTransfer/ResourcePermission.cs	(revision 15962)
+++ 	(revision )
@@ -1,39 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Runtime.Serialization;
-
-namespace HeuristicLab.Services.Hive.DataTransfer {
-  [DataContract]
-  [Serializable]
-  public class ResourcePermission : HiveItem {
-    // info: this class is derived from HiveItem to simplify handling on the client side, altough it does not have a Id.
-    [DataMember]
-    public Guid ResourceId { get; set; }
-    [DataMember]
-    public Guid GrantedUserId { get; set; }
-    [DataMember]
-    public Guid GrantedByUserId { get; set; }
-
-    public ResourcePermission() { }
-  }
-}
